<script lang="ts">
export interface WaitBoxOptions {
	barrierBackground?: string
	edgeBackground?: string
	iconColor?: string
	rightIcon?: boolean
}
</script>


<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'

// using
const { t } = useI18n({
	messages: {
		en: {
			text0: "Now Loading",
			text1: "Please wait",
		},
		th: {
			text0: "กำลังโหลดข้อมูล",
			text1: "กรุณารอสักครู่",
		},
	},
})

// states
const defaultOptions = ref(<WaitBoxOptions>{
	barrierBackground: '#3339',
	edgeBackground: '#000',
	icon: '',
	iconColor: '#000',
	rightIcon: true,
})
const options = ref(<WaitBoxOptions>{
})
const opened = ref(<boolean>false)

// support states
const orderIcon = ref('')
const orderText = ref('')
const step = ref(0)
const timer = ref(<any>null)

// ----------------------------------------------------------------------

// exposed API
defineExpose({

	/**
	 * Set defaults options, before calling open().
	 */
	setDefaults: function (o: WaitBoxOptions): void {
		defaultOptions.value = { ...o }
		console.log(`WaitBox.defaultOptions: ${JSON.stringify(defaultOptions.value, null, 2)}`)
	},

	/**
	 * Checks if the wait box is opened or not.
	 */
	isOpen: function (): boolean {
		return opened.value
	},

	/**
	 * Opens wait box.
	 * Return true if the wait box is opened successfully.
	 * Otherwise, it is false.
	 */
	open: function (o?: WaitBoxOptions): boolean {
		return openThis(o)
	},

	/**
	 * Closes the wait box.
	 */
	close: function (): void {
		closeThis()
	},

	/**
	 * Async version of open(), wait and close().
	 */
	wait: async function <T>(callback: () => Promise<T>): Promise<T | null> {
		this.open()
		const ret = await callback()
		this.close()
		return ret
	},

})

// ----------------------------------------------------------------------

function openThis(o?: WaitBoxOptions): boolean {
	// checks if it already opened
	if (opened.value) {
		return false
	}

	options.value = { ...defaultOptions.value }
	if (o) {
		if (typeof o.barrierBackground === 'string')
			options.value.barrierBackground = o.barrierBackground
		if (typeof o.edgeBackground === 'string')
			options.value.edgeBackground = o.edgeBackground
		if (typeof o.iconColor === 'string')
			options.value.iconColor = o.iconColor
		if (typeof o.rightIcon === 'boolean')
			options.value.rightIcon = o.rightIcon
	}
	if (!options.value.iconColor)
		options.value.iconColor = '#000'
	opened.value = true
	console.log(`WaitBox.options: ${JSON.stringify(options.value, null, 2)}`)

	if (options.value.rightIcon) {
		orderIcon.value = 'order-2'
		orderText.value = 'order-1'
	}
	else {
		orderIcon.value = 'order-1'
		orderText.value = 'order-2'
	}
	step.value = 0

	timer.value = setInterval(() => {
		if (step.value >= 3)
			step.value = 0
		else
			step.value++

	}, 500)

	const e = document.activeElement as HTMLElement
	e.blur()

	return true
}

function closeThis(): void {
	if (opened.value) {
		clearInterval(timer.value)
		opened.value = false
	}
}
</script>


<style scoped>
#container {
	position: fixed;
	width: 100%;
	height: 100%;
	left: 0px;
	top: 0px;
}

#center {
	position: absolute;
	left: 50%;
	top: 50%;
	max-width: 24rem;
	transform: translate(-50%, -50%);
}

#dialog {
	border-radius: 1rem;
	border: 4px;
	box-shadow: 0.25rem 0.25rem #666c;
}

#content {
	display: flex;
	align-items: flex-start;
	gap: 1rem;
	border-radius: 1rem;
	border: 4px;
	padding: 1rem;
	background: #fff;
	color: #000;
}

#content>div:nth-child(1) {
	flex: 0 1 auto;
}

#content>div:nth-child(2) {
	flex: 1 1 auto;
}

.order-1 {
	order: 0;
}

.order-2 {
	order: 1;
}

.visible {
	visibility: visible;
}

.collapse {
	visibility: collapse;
}

.animate {
	animation-duration: .5s;
	animation-name: in;
}

@keyframes in {
	from {
		opacity: 0;
	}

	to {
		opacity: 1;
	}
}

.animate-spin {
	animation: spin 1s linear infinite;
}

@keyframes spin {
	from {
		transform: rotate(0deg);
	}

	to {
		transform: rotate(360deg);
	}
}
</style>


<template>
	<!-- background -->
	<div v-if="opened" id="container" :style="{ background: options.barrierBackground }" @click.prevent.stop="">
		<!-- the centered dialog box-->
		<div id="center" class="animate" @click.prevent.stop="">
			<!-- dialog box -->
			<div id="dialog" :style="{ borderColor: options.edgeBackground }">
				<div id="content">
					<div :class="orderIcon">
						<span class="material-symbols-outlined animate-spin" style="font-size: 3rem"
							:style="{ color: options.iconColor }">cycle</span>
					</div>
					<div :class="orderText">
						<p style="font-size: 1.25rem; line-height: 1.75rem">
							{{ t('text0') }}
						</p>
						<p>
							{{ t('text1') }}<span :class="step > 0 ? 'visible' : 'collapse'">.</span><span
								:class="step > 1 ? 'visible' : 'collapse'">.</span><span
								:class="step > 2 ? 'visible' : 'collapse'">.</span>
						</p>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>
